const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class TeachersDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const teachers = await db.teachers.create(
      {
        id: data.id || undefined,

        full_name: data.full_name || null,
        subject_specialization: data.subject_specialization || null,
        phone_number: data.phone_number || null,
        joining_date: data.joining_date || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await teachers.setUser(data.user || null, {
      transaction,
    });

    await teachers.setSchool(data.school || null, {
      transaction,
    });

    await teachers.setSchools(data.schools || null, {
      transaction,
    });

    return teachers;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const teachersData = data.map((item, index) => ({
      id: item.id || undefined,

      full_name: item.full_name || null,
      subject_specialization: item.subject_specialization || null,
      phone_number: item.phone_number || null,
      joining_date: item.joining_date || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const teachers = await db.teachers.bulkCreate(teachersData, {
      transaction,
    });

    // For each item created, replace relation files

    return teachers;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const teachers = await db.teachers.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.full_name !== undefined) updatePayload.full_name = data.full_name;

    if (data.subject_specialization !== undefined)
      updatePayload.subject_specialization = data.subject_specialization;

    if (data.phone_number !== undefined)
      updatePayload.phone_number = data.phone_number;

    if (data.joining_date !== undefined)
      updatePayload.joining_date = data.joining_date;

    updatePayload.updatedById = currentUser.id;

    await teachers.update(updatePayload, { transaction });

    if (data.user !== undefined) {
      await teachers.setUser(
        data.user,

        { transaction },
      );
    }

    if (data.school !== undefined) {
      await teachers.setSchool(
        data.school,

        { transaction },
      );
    }

    if (data.schools !== undefined) {
      await teachers.setSchools(
        data.schools,

        { transaction },
      );
    }

    return teachers;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const teachers = await db.teachers.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of teachers) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of teachers) {
        await record.destroy({ transaction });
      }
    });

    return teachers;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const teachers = await db.teachers.findByPk(id, options);

    await teachers.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await teachers.destroy({
      transaction,
    });

    return teachers;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const teachers = await db.teachers.findOne({ where }, { transaction });

    if (!teachers) {
      return teachers;
    }

    const output = teachers.get({ plain: true });

    output.assignments_teacher = await teachers.getAssignments_teacher({
      transaction,
    });

    output.class_subjects_teacher = await teachers.getClass_subjects_teacher({
      transaction,
    });

    output.classes_class_teacher = await teachers.getClasses_class_teacher({
      transaction,
    });

    output.lesson_plans_teacher = await teachers.getLesson_plans_teacher({
      transaction,
    });

    output.student_attendance_marked_by =
      await teachers.getStudent_attendance_marked_by({
        transaction,
      });

    output.teacher_attendance_teacher =
      await teachers.getTeacher_attendance_teacher({
        transaction,
      });

    output.timetables_teacher = await teachers.getTimetables_teacher({
      transaction,
    });

    output.user = await teachers.getUser({
      transaction,
    });

    output.school = await teachers.getSchool({
      transaction,
    });

    output.schools = await teachers.getSchools({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userSchools = (user && user.schools?.id) || null;

    if (userSchools) {
      if (options?.currentUser?.schoolsId) {
        where.schoolsId = options.currentUser.schoolsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.users,
        as: 'user',

        where: filter.user
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.user
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  firstName: {
                    [Op.or]: filter.user
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.schools,
        as: 'school',
      },

      {
        model: db.schools,
        as: 'schools',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.full_name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('teachers', 'full_name', filter.full_name),
        };
      }

      if (filter.subject_specialization) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'teachers',
            'subject_specialization',
            filter.subject_specialization,
          ),
        };
      }

      if (filter.phone_number) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'teachers',
            'phone_number',
            filter.phone_number,
          ),
        };
      }

      if (filter.joining_dateRange) {
        const [start, end] = filter.joining_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            joining_date: {
              ...where.joining_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            joining_date: {
              ...where.joining_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.school) {
        const listItems = filter.school.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolId: { [Op.or]: listItems },
        };
      }

      if (filter.schools) {
        const listItems = filter.schools.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.schoolsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.teachers.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('teachers', 'full_name', query),
        ],
      };
    }

    const records = await db.teachers.findAll({
      attributes: ['id', 'full_name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['full_name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.full_name,
    }));
  }
};
